Unit AFP2C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFP2C(var A :Array of Complex; N :Integer; M :Integer;
                var W :Array of Complex; var S :Array of Integer);

implementation

procedure AFP2C(var A :Array of Complex; N :Integer; M :Integer;
                var W :Array of Complex; var S :Array of Integer);
var
I,J,B,G,H :Integer;
C,D,F,K,R,T,Z,BA,BD,BE,BI :Real;
E,X,BH :Complex;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27;
begin
for B:=1 to M do
 begin
  if ( B <> N ) 
   then goto _1;
  W[B-1] := A[(B-1)+(B-1)*N];
  A[(B-1)+(B-1)*N] := Cmplx(0.0,0.0);
  goto _27;
_1:
  H := B;
  C := 0.0;
  for J:=B to M do
   begin
    F := 0.0;
    for I:=B to N do
     begin
      BD := Creal(A[(I-1)+(J-1)*N]);
      BE := Aimag(A[(I-1)+(J-1)*N]);
      BD := Abs(BD);
      BE := Abs(BE);
      if ( BD-BE ) < 0
       then goto _3
       else if ( BD-BE ) > 0
             then goto _2
             else goto _2;
_2:
      T := BD;
      goto _4;
_3:
      T := BE;
_4:
      if ( T = 0.0 ) 
       then goto _5;
      BD := BD/T;
      BE := BE/T;
      BD := BD*BD+BE*BE;
      T := T*Sqrt(BD);
_5:
      if ( F >= T ) 
       then goto _6;
      F := T;
_6:
     end;
    if ( F = 0.0 ) 
     then goto _8;
    D := 0.0;
    for I:=B to N do
     begin
      K := 0.0;
      BI := Creal(A[(I-1)+(J-1)*N])/F;
      K := K+BI*BI;
      BI := Aimag(A[(I-1)+(J-1)*N])/F;
      K := K+BI*BI;
      D := D+K;
_7:
     end;
    F := Sqrt(D)*F;
_8:
    if ( C >= F ) 
     then goto _9;
    C := F;
    H := J;
_9:
   end;
  if ( H = B ) 
   then goto _11;
  for I:=1 to N do
   begin
    X := A[(I-1)+(H-1)*N];
    A[(I-1)+(H-1)*N] := A[(I-1)+(B-1)*N];
    A[(I-1)+(B-1)*N] := X;
_10:
   end;
_11:
  S[B-1] := H;
  for I:=B to N do
   begin
    W[I-1] := A[(I-1)+(B-1)*N];
_12:
   end;
  if ( C = 0.0 ) 
   then goto _26;
  R := 1.0/C;
  for I:=B to N do
   begin
    W[I-1] := MulC(W[I-1],Cmplx(R,0.0));
_13:
   end;
  Z := Creal(W[B-1]);
  BA := Aimag(W[B-1]);
  Z := Abs(Z);
  BA := Abs(BA);
  if ( Z-BA ) < 0
   then goto _15
   else if ( Z-BA ) > 0
         then goto _14
         else goto _14;
_14:
  R := Z;
  goto _16;
_15:
  R := BA;
_16:
  if ( R = 0.0 ) 
   then goto _17;
  Z := Z/R;
  BA := BA/R;
  Z := Z*Z+BA*BA;
  R := R*Sqrt(Z);
_17:
  if ( R <> 0.0 ) 
   then goto _18;
  E := Cmplx(1.0,0.0);
  W[B-1] := Cmplx(1.0,0.0);
  goto _20;
_18:
  E := DivC(W[B-1],Cmplx(R,0.0));
  W[B-1] := AddC(W[B-1],E);
  R := 1.0/Sqrt(1.0+R);
  for I:=B to N do
   begin
    W[I-1] := MulC(W[I-1],Cmplx(R,0.0));
_19:
   end;
_20:
  E := MulC(SubC(Cmplx(0.0,0.0),Cmplx(C,0.0)),E);
  for I:=B to N do
   begin
    A[(I-1)+(B-1)*N] := W[I-1];
_21:
   end;
  if ( B = M ) 
   then goto _25;
  G := B+1;
  for J:=G to M do
   begin
    BH := Cmplx(0.0,0.0);
    for I:=B to N do
     begin
      BH := AddC(BH,MulC(A[(I-1)+(J-1)*N],Conjg(W[I-1])));
_22:
     end;
    for I:=B to N do
     begin
      A[(I-1)+(J-1)*N] := SubC(A[(I-1)+(J-1)*N],MulC(BH,W[I-1]));
_23:
     end;
_24:
   end;
_25:
  W[B-1] := E;
_26:
 end;
_27:
end;

end.
